


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable Address         0x0000
    variable Data            0x0000
    variable DataBlock       0x0000
    variable Length          1
    variable AddressModifier A16

    source Global.tcl


   proc  show_variables {} {
        variable Address
        variable Data
        variable Length
        variable AddressModifier

        InsertLog "Address=$Address; Data=$Data; Length=$Length; AddressModifier=$AddressModifier"
   }

    proc do_parameters {} {
        variable cgidata
        variable Address
        variable Data
        variable Length
        variable AddressModifier
        variable DataBlock
        variable LogFlag

        for {set i 2} {$i < [llength $cgidata]} {incr i} {

            set name [lindex $cgidata $i]
            incr i
            set value [lindex $cgidata $i]

            switch -glob $name {

               AddressModifier -
               Address  -
               Length -
               DataBlock -
               Data  {
                    variable $name
                    set $name $value
                    if {$LogFlag == 1} {InsertLog "$name = $value"}
               }
            }
        }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {
            do_parameters
            switch -glob [lindex $cgidata 1] {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                SET      {do_set}
                GET      {do_get}
                READ     {do_read}
                WRITE    {do_write}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

